<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 
/**
 * @file Reference.class.php
 * @desc Cette classe permet de referencer le site flash delfiweb.
 * 
 * @author Matthieu 
 *
 * @version 0.1 
 */
 

/**
 * @note : 
 *		- 
 *
 */

 
 /**
 * @details : 
 * 		- 
 *
 *
 * @usage :
 *		- $a_xmlTxt = array("xml/content/fr/accueil.xml", "xml/content/fr/news.xml");
		  $o_reference = new Reference($a_xmlTxt);
		  $o_reference->createFileHTML("include/page_content/contentXML.htm");
 *
 */
class Reference 
{
	/* caracterisitiques des chemins */
	private $a_XmlFile; 				// tableau avec tous les fichiers xml a lire

	
	
	
	// ---------------------------------- __construct() ----------------------------------------------------------
   /**
	* @brief Constructeur de la classe.
	* @param -
	*/
	public function __construct($a_XmlF)
	{
		$this->a_XmlFile = (array) $a_XmlF;
		
	}


	// -----------------------------------------------------------------------------------------------------------
	// -------------------------------------- M�thodes publiques  ------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	
	
	// ---------------------------------- createFileHTML() ----------------------------------------------------------
	/**
	* @brief Creation d'un fichier html a partir du cotnenu de plusieurs fichiers xml
	* 
	* @param (string) le chemin et le nom du fichier a creer
	* @return (boolean) true tout s'est bien passe sinon false
	*/
	public function createFileHTML($s_FileName)
	{
		/* init var */
		$s_documentXML = "";
		
		foreach($this->a_XmlFile as $key=> $value)
		{
			$s_fileUrl = $value;
			
			/* test la validite du fichier xml */
			libxml_clear_errors(); // vide le buffer d'erreur libxml
			
			//$o_SimpleXMLelementFlash = @simplexml_load_string($s_fileUrl, 'SimpleXMLElement'); // cree un objet SimpleXMLElement
			$o_SimpleXMLelementFlash = @simplexml_load_file($s_fileUrl);
			
			
			$o_LibXMLError = libxml_get_last_error(); // Lit la derniere erreur libxml concernant l'analyse de l'objet SimpleXMLElement
			// si il y a une erreur dans le noeud xml
			if( !empty($o_LibXMLError ) )
			{
				$s_message = $o_LibXMLError->message; // affiche le texte d'erreur
				libxml_clear_errors(); // vide le buffer d'erreur libxml
				echo " <br />- This xml file is incorrect : <br />".$s_message;
				return false;
			}
			
			/* recupere le contenu du noeud page_content (tous les noeud enfants) */
			foreach( $o_SimpleXMLelementFlash->page_content as $item )
			{
				$s_title = $item->title;// le contenu du noeud title
				$s_description = $item->description;// le contenu du noeud description				
			}
			
			$s_documentXML .= "<h1>".$s_title."</h1>".$s_description."<br /><br />";
			
			$a_xml 	= array("\n", "\r", "&");
			$a_html = array("<br />", "<br />", "&amp;");
			$s_documentXML = str_replace($a_xml, $a_html, $s_documentXML);// remplace les balises du fichier xml par des balises html
		}
		
		
		/* ecriture du texte dans un fichier html */
		$handle = fopen($s_FileName, "w+"); 
		$i_nb_octet = fwrite($handle, $s_documentXML ); // ecriture du fichier
		
		if( $i_nb_octet===FALSE )
		{
			echo " <br />- Error occured during the writing of xml file.";
			return false;
		}
		
		// sinon zcriture rzussi, ferme le fichier
		fclose($handle);
		return true;
	}


	
 	// -------------------------------------------------------------------------------------------------
	// ---------------------------------------- Divers  ------------------------------------------------
	// -------------------------------------------------------------------------------------------------

	
 	/**
	* @brief Destructeur de la classe
	* Utilis pour enregistrer des messages pour le debogage, fermer les fichiers ouverts en criture ou en lecture, raliser des operations
	* de nettoyage des objets utiliss...
	*
	* @param 
	* @return 
	*/
	public function __destruct() 
	{
 
 	}



	/**
	 * @brief Determine comment la classe doit reagir lorsqu'elle est convertie en chane de caracteres.
	 * 
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  la reprsentation de l'objet sous forme de chane.
	 */	
	public function __toString() 
	{
		
		$s_classContent = "[Object ".__CLASS__."]<br />";
		// parcours toutes les proprietes de la classe et les renvoie	
		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}

}
 
 
 

?>